/* -*- Mode: javascript; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

function lookUpSenders(event)
{
  var loadedFolder = AddressContext.GetLoadedMsgFolder();
  var messageArray = AddressContext.GetSelectedMessages();
  var emailArray = [];
  if (messageArray) {
    for(var msg in messageArray) {
      var messageUri = messageArray[msg];
      var hdr = messenger.messageServiceFromURI(messageUri).messageURIToMsgHdr(messageUri);
      var formattedAddress = emailCleanup(hdr.mime2DecodedAuthor || hdr.author);
      emailArray.push(formattedAddress[0]);
  
    }
    lookUpInBooks(emailArray);
  }
}

function lookUpRecipients(event)
{
  var addressArray = getRecipients(event);
  addressArray = makeSortedList(addressArray);
  addressArray = simplifyAddresses(addressArray);
  lookUpInBooks(addressArray);
}

function lookUpCard(emailNode)
{
  if(emailNode){
    var email = emailNode.getAttribute("emailAddress") ||
                emailNode.parentNode.parentNode.getAttribute("emailAddress");
    var emailArray = [];
    emailArray.push(email);
    lookUpInBooks(emailArray);
  }
}

function lookUpInBooks(emailArray){
  var abManager = Components.classes["@mozilla.org/abmanager;1"]
                            .getService(Components.interfaces.nsIAbManager);
  var enumerator = Components.classes["@mozilla.org/abmanager;1"]
                             .getService(Components.interfaces.nsIAbManager)
                             .directories;
  var matchFound;

  for(var i in emailArray){
    matchFound = false;
    // enumerate all of the address books on this system
  
    while (enumerator.hasMoreElements()) {
      var addrbook = enumerator.getNext()
                               .QueryInterface(Components.interfaces.nsIAbDirectory);  // an addressbook directory
      var searchUri = addrbook.URI + "?(or(PrimaryEmail,c," + emailArray[i] + "))";  // search for the address in this book
      var ChildCards = abManager.getDirectory(searchUri).childCards;
      if (ChildCards.hasMoreElements()) {
        // if the directory has *any* items, they will be matches of the address
        CurrentCard = ChildCards.getNext();
        if (CurrentCard instanceof Components.interfaces.nsIAbCard) {
          // current card is the addressbook card of a contact that has 'address'
          if (CurrentCard.primaryEmail.toLowerCase() == emailArray[i].toLowerCase()) {
            // open the 'edit contact dialog for this card
            var CurrentBookURI = addrbook.URI;
            window.openDialog("chrome://messenger/content/addressbook/abEditCardDialog.xul",
                               "",
                               "chrome,resizable,modal,titlebar,centerscreen",
                               {abURI: CurrentBookURI, card: CurrentCard, okCallback: null});
            matchFound = true;
            break;
          }
        }
      }

      // if no match found above
      // lets now search the 'second email' of all the contacts in this addressBook
      var searchUri = addrbook.URI + "?(or(SecondEmail,c," + emailArray[i] + "))";
      var ChildCards = abManager.getDirectory(searchUri).childCards;
      if (ChildCards.hasMoreElements()) {
        // if the directory has *any* items, they will be matches of the address
        CurrentCard = ChildCards.getNext();
        if (CurrentCard instanceof Components.interfaces.nsIAbCard) {
          var email = card.getProperty("SecondEmail", "");
          if (email && email.toLowerCase() == emailArray[i].toLowerCase()) {
            // open the 'edit contact dialog for this card
            var CurrentBookURI = addrbook.URI;
            window.openDialog("chrome://messenger/content/addressbook/abEditCardDialog.xul",
                               "",
                               "chrome,resizable,modal,titlebar,centerscreen",
                               {abURI: CurrentBookURI, card: CurrentCard, okCallback: null});
            matchFound = true;
            break;
          }
        }
      }
    }

    if(!matchFound) {
      if(confirm("No match found for " + emailArray[i] + ". Add to Address Book?")) {
        //window.openDialog("chrome://addresscontext/content/aCNewCardDialog.xul",
        window.openDialog("chrome://messenger/content/addressbook/abNewCardDialog.xul",
                          "",
                          "chrome,titlebar,modal,resizable=no",
                          {primaryEmail: emailArray[i]});
      }
    }
  }
}

function addSenderAsCard(event)
{
  var loadedFolder = AddressContext.GetLoadedMsgFolder();
  var messageArray = AddressContext.GetSelectedMessages();

  if (messageArray && messageArray.length > 0){
    for (var i = 0; i < messageArray.length; i ++)
    {
      var messageUri = messageArray[i];
      var hdr = messenger.messageServiceFromURI(messageUri)
                         .messageURIToMsgHdr(messageUri);
      var formattedAddress = emailCleanup(hdr.mime2DecodedAuthor || hdr.author);
      var args = {primaryEmail: formattedAddress[0]};
      if (formattedAddress[1])
        args.displayName = formattedAddress[1];
      if (formattedAddress[2])
        args.firstName = formattedAddress[2];
      if (formattedAddress[3])
        args.lastName = formattedAddress[3];
      //window.openDialog("chrome://addresscontext/content/aCNewCardDialog.xul",
      window.openDialog("chrome://messenger/content/addressbook/abNewCardDialog.xul",
                        "", "chrome,modal,resizable=no,centerscreen",
                        args);
    }
  }
}

function addRecipientsAsCards(event)
{
  var messageArray = getRecipients(event);
  if (messageArray && messageArray.length > 0){
    for (var i = 0; i < messageArray.length; i ++)
    {
      var formattedAddress = emailCleanup(messageArray[i]);
      var args = {primaryEmail: formattedAddress[0]};
      if (formattedAddress[1])
        args.displayName = formattedAddress[1];
      if (formattedAddress[2])
        args.firstName = formattedAddress[2];
      if (formattedAddress[3])
        args.lastName = formattedAddress[3];
      //window.openDialog("chrome://addresscontext/content/aCNewCardDialog.xul",
      window.openDialog("chrome://messenger/content/addressbook/abNewCardDialog.xul",
                        "", "chrome,modal,resizable=no,centerscreen",
                        args);
    }
  }
}

function addSendersAsList(event)
{
  var loadedFolder = AddressContext.GetLoadedMsgFolder();
  var messageArray = AddressContext.GetSelectedMessages();
  var allSenders;;
  if (messageArray && messageArray.length > 0){
    for (var i = 0; i < messageArray.length; i++){
      var messageURI = messageArray[i];
      var hdr = messenger.messageServiceFromURI(messageURI).messageURIToMsgHdr(messageURI);
      if (!allSenders) {
        allSenders = hdr.author;
      }
      else {
        allSenders += ', ';
        allSenders += hdr.author;
      }
    }
    var addressArray = createAddressList(allSenders);
    addressArray = makeSortedList(addressArray);
    addressArray = simplifyAddresses(addressArray);
    //window.openDialog("chrome://addresscontext/content/aCListDialog.xul",
    window.openDialog("chrome://messenger/content/addressbook/abMailListDialog.xul",
                      "", "chrome,modal,resizable,centerscreen",
                      {addressArray: addressArray});
  }
}

function getRecipients(event)
{
  var loadedFolder = AddressContext.GetLoadedMsgFolder();
  var messageArray = AddressContext.GetSelectedMessages();
  var longRecipients = null;
  if (messageArray && messageArray.length > 0){
    for (var i = 0; i < messageArray.length; i ++){
      var messageURI = messageArray[i];
      var hdr = messenger.messageServiceFromURI(messageURI).messageURIToMsgHdr(messageURI);
      if (longRecipients == null){
        longRecipients = hdr.recipients;
      }
      else{
        longRecipients += ', ';
        longRecipients += hdr.recipients;
      }
      if (hdr.ccList){
        ccPeople = hdr.ccList;
        if (longRecipients == null){
          longRecipients = hdr.ccList;
        }
        else{
          longRecipients += ', ';
          longRecipients += ccPeople;
        }
      }
    }
    addressArray = createAddressList(longRecipients);
    return addressArray;
  }
}

function addRecipientsAsList(event)
{
  addressArray = getRecipients(event);
  addressArray = makeSortedList(addressArray);
  addressArray = simplifyAddresses(addressArray);
  //window.openDialog("chrome://addresscontext/content/aCListDialog.xul",
  window.openDialog("chrome://messenger/content/addressbook/abMailListDialog.xul",
                    "",
                    "chrome,modal,resizable,centerscreen",
                    {addressArray: addressArray});
}

function emailCleanup(unformattedAddress)
{
  var primaryEmail;
  var displayName = null;
  if (unformattedAddress.search('<')!= -1){
    var beginpos = unformattedAddress.search('<');
    var endpos = unformattedAddress.search('>');
    beginpos--;
    displayName = unformattedAddress.slice(0, beginpos);
    beginpos = beginpos + 2;
    primaryEmail = unformattedAddress.slice(beginpos, endpos);
  }
  if (/\"/.test(displayName)){
    leftofquote = displayName.indexOf("\"") + 1;
    rightofquote = displayName.lastIndexOf("\"");
    displayName = displayName.substring(leftofquote, rightofquote);
  }
  if (displayName){
		lastName = /\w+$/.exec([displayName])
    firstName = displayName.replace(lastName, "")
		firstName = firstName.replace(/\s$/, "")
		formattedAddress = [];
    formattedAddress[0] = primaryEmail;
    formattedAddress[1] = displayName;
    formattedAddress[2] = firstName;
    formattedAddress[3] = lastName;
  }
  if (!displayName){
    primaryEmail = unformattedAddress;
    formattedAddress = new Array;
    formattedAddress[0] = primaryEmail;
    formattedAddress[1] = null;
    formattedAddress[2] = null;
    formattedAddress[3] = null;
  }
  return formattedAddress;
}

function createAddressList(addressList)
{
  var addressArray = [];
  var arrayElement = 0;
  while (addressList != ""){
    var commaDeclare = ",";
    if (addressList.search(commaDeclare) != -1){
      var blank = "";
      var commaPlace = addressList.indexOf("\,");
      var firstEntry = addressList.substr(0, commaPlace);
      var currentName = firstEntry.replace(/\s$/, "");
       //check for case of "Last Name, First Name" <email@address.com>
       if (/\"(?=\w+$)/.test(currentName) == true){
         commaPlace++;
         addressList = addressList.substr(commaPlace);
         if (addressList.search(commaDeclare) == -1){
           var secondEntry = addressList;
           var firstName = currentName;
           var currentName = firstName + "\,\ " + secondEntry;
           addressArray[arrayElement] = currentName;
           return addressArray;
         }
         else{
           var newCommaPlace = addressList.indexOf("\,");
           var secondEntry = addressList.substr(0, newCommaPlace);
         }
         addressList = addressList.replace(secondEntry, blank);
         var firstName = currentName;
         var currentName = firstName + "\,\ " + secondEntry;
         addressArray[arrayElement] = currentName;
       }
       else{
         addressArray[arrayElement] = currentName;
         commaPlace = commaPlace + 2;
         addressList = addressList.substr(commaPlace);
       }  
    }
    else if (addressList.search(commaDeclare) == -1 && addressList.length != 0){
      addressArray[arrayElement] = addressList;
      return addressArray;
    }
    arrayElement++;
  }
}

function makeSortedList(addressArray)
{
  i = 0;
  unsortedAddresses = [];
  for (i; i < addressArray.length; i++){
    unsortedAddresses[i] = emailCleanup(addressArray[i]);
  }
  sortedAddresses = unsortedAddresses.sort(addressSortFunction);
  addressArray = checkDuplicates(sortedAddresses);
  return addressArray;
}

function checkDuplicates(sortedAddresses)
{
  //count the duplicates
  i = 0;
  k = 0;
  noDupes = new Array;
  for (i; i < (sortedAddresses.length);)
  {
    j = i + 1;
    if (j < (sortedAddresses.length)){
      counter = 0;
      while (sortedAddresses[i][0] == sortedAddresses[j][0])
      {
        counter++;
        j++;
        if (j == (sortedAddresses.length)){
          break}
      }
    }
    noDupes[k] = sortedAddresses[i];
    i = j;
    k++;
  }
  return noDupes;
}
// function checkDuplicates(addressArray)
// {
   // i = 0;
   // for (i; i < (addressArray.length - 1); i++){
     // j = i + 1;
     // for (j; j < addressArray.length; j++){
       // if (addressArray[i] !== null && addressArray[j] !== null){
         // var firstEmail = addressArray[i];
         // var secondEmail = addressArray[j];
         // firstToCompare = new Array;
         // secondToCompare = new Array;
         // var unformattedAddress;
         // firstToCompare = emailCleanup(firstEmail);
         // secondToCompare = emailCleanup(secondEmail);
         // if (firstToCompare[0] == secondToCompare[0]){
           // if (firstToCompare[1] !== null && secondToCompare[1] !== null){
             // if (firstToCompare[1].length > secondToCompare[1].length){
               // addressArray[j] = null}
             // else {
               // addressArray[i] = addressArray[j];
               // addressArray[j] = null};
           // }
           // else if (firstToCompare[1] !== null && secondToCompare[1] == null){
            // addressArray[j] = null}
           // else if (firstToCompare[1] == null && secondToCompare[1] !== null){
            // addressArray[i] = addressArray[j];
            // addressArray[j] = null}
           // else if (firstToCompare[1] == null && secondToCompare[1] == null){
            // addressArray[j] = null}
         // }
       // }
     // }
   // }
   // return addressArray;
// }

function simplifyAddresses(addressArray)
{
  simplifiedAddresses = new Array;
  i = 0;
  for (i;i<addressArray.length;i++)
  {
    if (addressArray[i][1] == null){
      simplifiedAddresses[i] = addressArray[i][0];
    }
    else{
      simplifiedAddresses[i] = addressArray[i][1] + ' <' + addressArray[i][0] + '>';
    }
  }
  return simplifiedAddresses;
}

function addressSortFunction(a,b) {
  if (a[0]<b[0]) return -1;
  if (a[0]>b[0]) return 1;
  return 0;
}

// Thunderbird compatibility function.
function getPref(aPrefName, aIsComplex)
{
  if (aIsComplex)
      return GetStringPref(aPrefName);

  switch (Services.prefs.getPrefType(aPrefName))
  {
    case Components.interfaces.nsIPrefBranch.PREF_BOOL:
      return Services.prefs.getBoolPref(aPrefName);
    case Components.interfaces.nsIPrefBranch.PREF_INT:
      return Services.prefs.getIntPref(aPrefName);
    case Components.interfaces.nsIPrefBranch.PREF_STRING:
      return Services.prefs.getCharPref(aPrefName);
    default: // includes nsIPrefBranch.PREF_INVALID
      return null;
  }
}

var AddressContext = {

  GetSelectedMessages: function() {
    return gFolderDisplay.selectedMessageUris;
  },

  GetLoadedMsgFolder: function() {
    if (!gDBView)
      return null;
    return gDBView.msgFolder;
  },

}
